
#pragma warning(disable:4786)

#ifndef __BURBULATOR_H
#define __BURBULATOR_H

#include <d3dx8math.h>
#include "../utils/Pool.h"
#include <list>

class CResources;
class CWaterSurface;


class CBurbulator {
public:
	struct SBubble {
		D3DXVECTOR3	mPosition;
		float		mSize;
		float		mAge;
		bool		mWasAtSurface;
	};
	typedef CPool<SBubble>		TBubblePool;
	typedef CPool<SBubble*>		TBubblePtrPool;
	
public:
	CBurbulator( CResources& resources )
		: mResources( &resources ) { }
	
	void	update( float deltaTime, CWaterSurface& surface );

	const TBubblePool& getBubbles() const { return mBubbles; }
	
private:
	CResources*		mResources;
	TBubblePool		mBubbles;
	TBubblePtrPool	mBubblesAtSurface;
};


#endif
