
#ifndef __RESOURCES_H
#define __RESOURCES_H

#include "../DXObject.h"
#include <d3dx8.h>

class CFluid;


const float R_FLUID_RADIUS = 85.0f;
const float R_FLUID_RADIUS2 = R_FLUID_RADIUS * R_FLUID_RADIUS;
const float R_FLUID_HEIGHT = 70.0f;


class CResources : public CDXObject {
public:
	CResources();
	
	void init( CFluid& fluid );

	virtual HRESULT onCreateDevice( IDirect3DDevice8* device );
	virtual HRESULT onLostDevice();
	virtual HRESULT onResetDevice();
	virtual HRESULT onDestroyDevice();
	
public:

	CFluid*		mFluid;
	
	IDirect3DTexture8*		mTexEnvi;
	IDirect3DTexture8*		mTexBowl;
	IDirect3DTexture8*		mTexPoint;
	
	ID3DXEffect*			mEfxWater;
	ID3DXEffect*			mEfxParticle;
	ID3DXEffect*			mEfxBaseTexEnvi;
	ID3DXEffect*			mEfxBlendEnvi;
	
	ID3DXMesh*				mMeshBowl;
	ID3DXMesh*				mMeshWater; // systemmem
	ID3DXMesh*				mMeshWaterSystem; // systemmem, xyz
	ID3DXMesh*				mMeshWaterDynamic; // dynamic|writeonly, xyz|normal
	
	D3DMATERIAL8			mMaterialBowl;
	D3DMATERIAL8			mMaterialWater;
};

#endif
